<?php

    /**
     * User: Daschmi (daschmi@daschmi.de)
     * Date: 18.05.2017
     * Time: 08:57
     */

    namespace wpsg;
 
    class Exception extends \Exception
    {
        
        const TYP_UNEXPECTED = 0;
        const TYP_DB = 1;
         
        private $_typ = null;
        
        public function __construct($message, $typ = null, $arData = array(), $code = 0, Exception $previous = null)
        {
                        
            parent::__construct($message, $code, $previous);
            
            if ($typ === null) $typ = self::TYP_UNEXPECTED;
            
            $this->_typ = $typ;
            
            $strLogText  = date('d.m.Y H:i:s').': '.str_pad($this->getTypLabel(), 50, ' ')."\r\n";             
            $strLogText .= $this->getMessage()."\r\n";
                        
            foreach ($arData as $d)
            {
                
                $strLogText .= $d[0].': '.$d[1]."\r\n";
                
            }
            
            ob_start();
            debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 4);
            $strLogText .= ob_get_contents();
            ob_end_clean();
            
            $strLogText .= str_pad('', 120, '-')."\r\n";
            
            $log_file = $GLOBALS['wpsg_sc']->getStorageRoot().'exception.log';
            
            if (file_exists($log_file)) file_put_contents($log_file, $strLogText.file_get_contents($log_file));
            else file_put_contents($log_file, $strLogText); 
            
        } // public function __construct($message, $code = 0, Exception $previous = null)
 
        public function getTypLabel() 
        {
        
            switch ($this->_typ)
            {
                
                case 0: return __('Unerwartetes Programmverhalten', 'wpsg'); break;
                case 1: return __('Datenbankfehler', 'wpsg'); break;
                
                default: return __('Ungekannter Fehlertyp', 'wpsg'); break;
                
            } // switch ($this->_typ)
            
        } // public function getTypLabel()
        
    } // class exception extends \Exception