<?php

	/**
	 * Gutscheinmodel
	 * @author Daschmi
	 */
	class wpsg_voucher extends wpsg_model
	{

		/**
		 * Lädt die Daten des Gutscheins
		 */
		public function load($voucher_id)
		{

			parent::load($voucher_id);

			$this->data = $this->db->fetchRow("
				SELECT 
					V.* 
				FROM
					`".WPSG_TBL_GUTSCHEIN."` AS V
				WHERE
					V.`id` = '".wpsg_q($voucher_id)."'
			");

			if ($this->data['id'] != $voucher_id || !wpsg_isSizedInt($voucher_id)) return false;

			return true;

		} // public function __construct($voucher_id)

        public function getUsed()
        {

			return intval($this->db->fetchOne("SELECT COUNT(*) FROM `".WPSG_TBL_ORDER."` WHERE `gs_id` = '".wpsg_q($this->id)."' "));
			
        }

        public function getStatusLabel()
        {

			if ($this->multi === '1')
			{
				
				if (current_time('timestamp') < strtotime($this->start_date) || current_time('timestamp') > strtotime($this->end_date))
				{
					
					if ($this->getUsed() > 0) return __('Verbraucht', 'wpsg');
					else return __('Inaktiv', 'wpsg');
					
				}
				else return __('Aktiv', 'wpsg');
				
			}
			else
			{
				
				if ($this->getUsed() > 0) return __('Verbraucht', 'wpsg');
				else
				{
				
					if (current_time('timestamp') < strtotime($this->start_date) || current_time('timestamp') > strtotime($this->end_date)) return __('Inaktiv', 'wpsg');
					else return __('Aktiv', 'wpsg');
					
				}
				
			}

        }

        public function getStatus()
        {
        	
        	if ($this->multi === '1')
        	{
        		
        		if (current_time('timestamp') < strtotime($this->start_date) || current_time('timestamp') > strtotime($this->end_date))
        		{
        			
        			if ($this->getUsed() > 0) return 2;   //('Verbraucht', 'wpsg');
        			else return 1; 	//('Inaktiv', 'wpsg');
        			
        		}
        		else return 0;	//__('Aktiv', 'wpsg');
        		
        	}
        	else
        	{
        		
        		if ($this->getUsed() > 0) return 2;	//('Verbraucht', 'wpsg');
        		else
        		{
        			
        			if (current_time('timestamp') < strtotime($this->start_date) || current_time('timestamp') > strtotime($this->end_date)) return 1; 	//('Inaktiv', 'wpsg');
        			else return 0; 	//('Aktiv', 'wpsg');
        			
        		}
        		
        	}
        	
        }
        
        public function delete()
        {

            $this->db->Query("DELETE FROM `".WPSG_TBL_GUTSCHEIN."` WHERE `id` = '".wpsg_q($this->id)."' ");

        }

        /* Statische Funktionen */

		public static function count($arFilter = array())
		{

			list($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER) = self::getQueryParts($arFilter);

			$strQuery = "
				SELECT
					COUNT(*)
				FROM
					(
						SELECT
						  	DISTINCT V.`id`
						FROM
							`".WPSG_TBL_GUTSCHEIN."` AS V
							".$strQueryJOIN."
						WHERE
							1
							".$strQueryWHERE." 
						HAVING
							1
							".$strQueryHAVING."											
					) AS innerSelect
			";

			return $GLOBALS['wpsg_db']->fetchOne($strQuery);

		} // public static function count($arFilter = array())

		/**
		 * Gibt einen Array von Kundengruppen zurück, die auf den übergebenen Filter passen
		 * @param array $arFilter
		 */
		public static function find($arFilter = array())
		{

			list($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER) = self::getQueryParts($arFilter);

			$strLimit = "";

			if (wpsg_isSizedArray($arFilter['limit'])) $strLimit = "LIMIT ".wpsg_q($arFilter['limit'][0]).", ".wpsg_q($arFilter['limit'][1]);

			$strQuery = "
				SELECT
					V.`id`
					".$strQuerySELECT."
				FROM
					`".WPSG_TBL_GUTSCHEIN."` AS V
						".$strQueryJOIN."
				WHERE
					1
					".$strQueryWHERE."
				HAVING
					1
					".$strQueryHAVING."
				ORDER BY
					".$strQueryORDER."		
				".$strLimit."
			";

			$arID = $GLOBALS['wpsg_db']->fetchAssocField($strQuery);
			$arReturn = array();

			foreach ($arID as $id)
			{

				$arReturn[$id] = self::getInstance($id);

			}

			return $arReturn;


		} // public static function find($arFilter = array())

		public static function getQueryParts($arFilter = array())
		{

			$strQuerySELECT = "";
			$strQueryWHERE = "";
			$strQueryJOIN = "";
			$strQueryHAVING = "";
			$strQueryORDER = "";

 			if (wpsg_isSizedString($arFilter['s'])) $strQueryWHERE .= " AND V.`code` LIKE '%".wpsg_q($arFilter['s'])."%' ";

			if (wpsg_isSizedString($arFilter['code'])) $strQueryWHERE .= " AND V.`code` LIKE '%".wpsg_q($arFilter['code'])."%' ";

			if (wpsg_isSizedString($arFilter['order'], 'code')) { $strQueryORDER = " V.`code` "; }
            else if (wpsg_isSizedString($arFilter['order'], 'start_date')) { $strQueryORDER = " V.`start_date` "; }
            else if (wpsg_isSizedString($arFilter['order'], 'end_date')) { $strQueryORDER = " V.`end_date` "; }
            else if (wpsg_isSizedString($arFilter['order'], 'value')) { $strQueryORDER = " V.`value` "; }
			else $strQueryORDER = " V.`id` ";

			// Richtung
			if (wpsg_isSizedString($arFilter['ascdesc'], "DESC")) $strQueryORDER .= " DESC ";
			else $strQueryORDER .= " ASC ";

			return array($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER);

		}

	} // class wpsg_voucher

?>